Unit AM12R_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc;

procedure AM12R(AJ :Real; AJP1 :Real; var UJ :Real; var UJP1 :Real;
                var VJ :Real; var VJP1 :Real); 
implementation

procedure AM12R(AJ :Real; AJP1 :Real; var UJ :Real; var UJP1 :Real;
                var VJ :Real; var VJP1 :Real);
var
S,R :Real;
const
ZERO :Real = 0.0;
ONE :Real = 1.0;
label
_1,_2;
begin
if ( AJP1 = ZERO ) 
 then goto _1;
S := Abs(AJ)+Abs(AJP1);
UJ := AJ/S;
UJP1 := AJP1/S;
R := Sqrt(UJ*UJ+UJP1*UJP1);
if ( UJ < ZERO ) 
 then R := -R;
VJ := -(UJ+R)/R;
VJP1 := -UJP1/R;
UJ := ONE;
UJP1 := VJP1/VJ;
goto _2;
_1:
UJ := ZERO;
_2:
end;

end.
